#!/usr/bin/perl -I/usr/local/lib/simusol
# se ha agregado $opt_hash{noclas} = 1
use strict;
use warnings;
use Data::Dumper;
$Data::Dumper::Sortkeys= 1;
use Getopt::Long;
use Pod::Usage;
#use locale
#use POSIX;
#use POSIX qw(locale_h);
use Ayudas;
use Auxiliares;
use GlobalesSimusol;
print STDERR "SIMUSOLBINDIR simusol1.pl lolisol_sceptre.pl simusol3.pl $SIMUSOLBINDIR\n";
our %opciones;
our (@extensionesbackup,@extensionescomp);
#----------------------------------------------------------------------------
$0 =~ m!/([^/]+)\s*$!;
$progname = $1;my $curdirori = `pwd`; chomp $curdirori; $curdirori .= '/';
$progr{$progname} = '0';
print STDERR "$progname @ARGV\n";
(my $SIMUSOLBINDIR0 = $0) =~ s/^(.+)\/$progname/$1/;
$SIMUSOLBINDIR0 eq $SIMUSOLBINDIR or
    error_progr(__FILE__,__LINE__,"$SIMUSOLBINDIR-$SIMUSOLBINDIR0");
# --------------------------------------------------------------------------   
my $ref0 = {'curdirori' => $curdirori};
crear_tmp_simusol();
my ($coderr,$mensaje) = interpretar_opciones_0($ref0);
my (@dirarray, @archivos, @sindia, $ext);
# ---------------------------------------------------------------------------
our ($opciones_sim1,$opciones_sims,$opciones_sim3) = ('','','');
my $imprlog = '';
# --------------------------------------------------------------------------   
foreach my $palabra (qw(corto cortosin basearchcorto dirarray codigo_s codigo_s codigo_3)) {
    $ref0->{$palabra} = [];
};    
impr_todo(__LINE__.' sim0',$ref0);
($coderr,$mensaje) = atender_argumentos_0($ref0);
if (not $coderr) {
    impr_todo(__LINE__.' sim0',$ref0);
    ($coderr,$mensaje) = atender_opciones_independientes($ref0);
    $coderr and parary($coderr,$mensaje);    
    ($coderr,$mensaje) = procesar_diagramas($ref0);
#    atender_opciones_finales($ref0);
};    
parar0($coderr,$mensaje);
# termina el principal
# --------------------------------------------------------------------------   
sub atender_argumentos_0{  
  my  $ref0 = $_[0];
  print STDERR ".....  com0 atender_argumentos_0($ref0) \n";
  my ($coderr,$mensaje) = ('','');
  my $largo = 60 - length($progname); 
  my $opc_arg = paraimpr3puntos($largo,@ARGV);
   if (not $coderr) {  
      impr_debug(__LINE__.' sim0 %opt_hash',\%opt_hash);
      $imprlog = $opt_hash{d} or $imprlog = $opt_hash{noverb};
      open LOGPRIN,">$ref0->{outdir}".'simusol.log' or do {
        $mensaje = " No pude abrir simusol.log en $ref0->{outdir}";
        $coderr = 251;
	parar0($coderr,$mensaje);
      };
  };
  # -------------------------------------------------------
  print LOGPRIN "\#$marca_Simusol",`date`,"\n";
  print LOGPRIN "Resultados de llamados por S I M U S O L
        por comando $progname $opc_arg\n";
  # ---------------------------------------------------------------------------
  if (not $opt_hash{buscar}) {
      ($coderr,$mensaje) = interpretar_argumentos_no_buscar_0($ref0);
  } else {
      ($coderr,$mensaje) = interpretar_argumentos_buscar_0($ref0);
  };
  if (not $coderr) {    
      impr_todo(__LINE__.' sim0',$ref0);   
      if (@{$ref0->{dirarray}} == 0) {
	  $coderr = 252; $mensaje = " No quedaron diagramas para procesar";
       };	  
  };
  @{$ref0->{dirarray}} > 1 and ($coderr,$mensaje) = interpretar_argumentos_0($ref0);
  $coderr and parar0($coderr,$mensaje);
  comfin('fin0 atender_argumentos_0 $coderr,$mensaje',$coderr,$mensaje);
  return $coderr,$mensaje;
}#atender argumentos_0
# --------------------------------------------------------------------------   
sub atender_opciones_independientes{
  comfin('com0 atender_opciones_independientes',@_);
  my $ref0 = $_[0];
  if ($opt_hash{impr}) {
      explic(
      "Por preparar archivos para inclusión en documentos (o impresión)");
       map(impre_diag($_),@$ref0->{dirarray});
       explic('=' x 70);
       parar0(0,'');
  };
  if ($opt_hash{backup}) {
      impr_debug(__LINE__.' sim0 %dirsalida',Dumper \%dirsalida);
      impr_debug(__LINE__.' sim0 %dirsal',Dumper \%dirsal);
      backupear($ref0);
      parar0(0,'');
  };
  my $nn = $opt_hash{borrarbackups};
  if ($nn) {
      borrarbackups($ref0,$nn);
      parar0(0,'');
  };    
  if ($opt_hash{listar}) { 
# para hacer un comprimido de los archivos de interés
      my @dirwsin = @$ref0->{dirarray};
      print  join ("\n",@$ref0->{dirarray}), "\n";
      print "Quiere hacer un comprimido de  lo relacionado 
       (extensiones res sim simul caj d par paraplot par) 
          de nombre diagramas.tar.gz? (s|y|n)  ";
      my $resp =<STDIN>;
      lc($resp) =~ /[sy]/ or parar0(0,''); 
      my @todos = @$ref0->{dirarray};
      map (~ s/\.dia$//,@$ref0->{dirarray});
      for my $ext ('res','sim','simul','caj','d','gra','paraplot') {
          my @otros = @$ref0->{dirarray};
          map (do {$_ .= ".$ext"; $_ = $dirsalida{$ext}."/$_"} ,@otros); 
          impr_debug(__LINE__.' sim0',\@otros);
          @otros = grep (do{-f $_},@otros); 
          push @todos,@otros;
       };
       impr_debug(__LINE__.' sim0',\@todos);
       my $todosstring = join ' ',@todos;
#       system "tar -czvf diagramas.tar.gz $todosstring"; 
       parar0(0,'');
  };
  if ($opt_hash{ejecutar}) {
#   busca los archivos provenientes de diagramas, de extension (sin punto) 
#       $ot_hash{extension}
#   y ejecuta sobre ellos el comando 
#        $opt_hash{ejecutar}
#el comando podrá aceptar hasta dos archivos.
#primero el de extension dada y luego el de "dia"
      my $dd = './'; $opt_hash{outdir} and $dd = $opt_hash{outdir};
      $dd =~ s/\/\/$/\//;
      my $comando = $opt_hash{ejecutar};
      my $ext = $opt_hash{extension};
      defined $ext or $ext = 'dia';
      my @lista = @$ref0->{dirarray}; 
      impr_debug(__LINE__.' sim0 @lista', \@lista);
      $ext eq 'dia' or do {
	  my $ddext = "$dd$dirsalida{$ext}/";
        map(do{$_ = "$ddext$_";s/\.dia$//;s/$/.$ext/},@lista);
      };
      impr_debug(__LINE__.' sim0 @lista', \@lista);
      foreach (@lista) {
         impr_debug(__LINE__.' sim0 $_',$_); 
         my $sinext = $_; $sinext =~ s/\.$ext$//;
          next unless -e $_;
          system "echo __LINE__ $comando $_;$comando $_";
      };
      parar0(0,'')
  };
  comfin('fin0 atender_opciones_independientes');
  return '';
}#atender_opciones_independientes
#----------------------------------------------------------------------------
sub backupear{ 
  comfin('com0 backupear',@_);
  my $ref0 = $_[0]; my $n;
  my $extls3 = 'ls3';
  $opt_hash{noclas} and $extls3 = 'lss1';      
  push @extensionesbackup,$extls3,'cache';
  impr_debug(__LINE__.' Auxi @extensionesbackup',\@extensionesbackup);
  for (my $numarch= 0; $numarch < @{$ref0->{cortosin}};$numarch ++) {
      my $cortosin = $ref0->{cortosin}->[$numarch];
      (my $propiosin = $cortosin) =~ s/^[^\/]+\///;
      impr_debug(__LINE__.' Auxi $propiosin',$propiosin);         
      my $corto = $ref0->{corto}->[$numarch];
      (my $propio = $corto) =~ s/^[^\/]+\///;
      my $archtob ="$ref0->{outdir}$ref0->{basearchcorto}->[$numarch]$propiosin";
      my $archtobcaj = "$dirsal{caj}$archtob.caj"; 
      impr_debug(__LINE__.' Auxi $archtob,$archtobcaj',
        [$archtob,$archtobcaj]);         
      next  unless -s $archtobcaj;
      my $n = 1;
      while (-e "$archtobcaj$n"){$n++};
      impr_debug(__LINE__.' Auxi %dirsal',\%dirsal);
      foreach my $ext (@extensionesbackup) {
          system  "cp $dirsal{$ext}$archtob.$ext $dirsal{$ext}$archtob.$ext$n"
             if -e "$dirsal{$ext}$archtob.$ext";
      };
      foreach my $dirg (values %dirguardar) {
          if (-e "$dirg/$propio") {
              system "cp $dirg/$propio $dirg/$propio$n";
          };
      };	
  };
  print 'Únicamente se hizo "backup"s de archivos 
       '. join(' ',@extensionesbackup),"\n";
  comfin('fin0 backupear');
  return '';
}#backupear
# ---------------------------------------------------------------------------
sub borrarbackups{#elimina backups desde $nn
  comfin('com0 borrar_backups',@_);
  my ($ref0,$nn) = @_;
  my $extls3 = 'ls3';
  $opt_hash{noclas} and $extls3 = 'lss1';      
  push @extensionesbackup,$extls3,'cache';
  if (not defined $nn or $nn !~ /^\d/) {
      print STDERR " No se entiende -borrarbackups $nn\n";
      exit;
  };
  for (my $numarch= 0; $numarch < @{$ref0->{cortosin}};$numarch ++) {
      my $cortosin = $ref0->{cortosin}->[$numarch];
      (my $propiosin = $cortosin) =~ s/^[^\/]+\///;
      impr_debug(__LINE__.' Auxi $propiosin',$propiosin);         
      my $corto = $ref0->{corto}->[$numarch];
      (my $propio = $corto) =~ s/^[^\/]+\///;
      my $archtob ="$ref0->{outdir}$ref0->{basearchcorto}->[$numarch]$propiosin";
      my $archtobcaj = "$dirsal{caj}$archtob.caj"; 
      impr_debug(__LINE__.' Auxi $archtob,$archtobcaj',
        [$archtob,$archtobcaj]);         
      next  unless -s $archtobcaj;
      foreach my $ext (@extensionesbackup) {
	  my $archext = "$dirsal{$ext}$archtob.$ext";
	  if (-e $archext) {
	      my @lista = `ls $archext*`;
	      foreach my $arch (@lista) {
		  if ($arch =~ /^$archext(\d+)$/) {
	              my $agre = $1;
                      if ($agre >= $nn) {system  "rm $archext$agre"};
		  };    
	      };    
          };
      };	  
      foreach my $dirg (values %dirguardar) {
	  my $archext = "$dirg/$propio";
          if (-e $archext) {
	      my @lista = `ls $archext*`;
	      foreach my $arch (@lista) {
                  if ($arch =~ /^$archext(\d+)$/) {;
		      my $agre = $1;
                      if ($agre >= $nn) {system  "rm $archext$agre"};
		  };
	      };	  
	  };    
      };	
  };    
  comfin('fin0 borrarbackups');
}#borrarbackups
# ---------------------------------------------------------------------------
sub cargar_opciones_generales{
  comfin('com0 cargar_opciones_generales',@_);
  if ($opt_hash{d}) {
      $opciones{sim1} = $opciones{sims} = $opciones{sim3} = ' -d';
  };
  if ($opt_hash{noclas}) {
      $opciones{sim1} .= ' -noclas';
      $opciones{sims} .= ' -noclas';
      $opciones{sim3} .= ' -noclas';
  };
  if ($opt_hash{noverb}) { 
      $opciones{sim1} .= ' -noverb';
      $opciones{sims} .= ' -noverb';
      $opciones{sim3} .= ' -noverb';
  };
  if (not $opt_hash{notrad}) {
      $opciones{sim1} .= " -todas \'$opt_hash{todas}\' " if $opt_hash{todas};
      $opciones{sim1} .= ' -cadena  ' if $opt_hash{cadena};
  };
  if (not $opt_hash{nosim}) {    
      $opciones{sims} .= ' -adsim ' if $opt_hash{adsim};
  };
  if ($opt_hash{graf}) {    
      $opciones{sim3} .= " -graf $opt_hash{graf} ";
  }; 
  comfin('fin0 cargar_opciones_generales');
  return;    
}#cargar_opciones;    
# ---------------------------------------------------------------------------
sub graficar_diagrama{
  comfin('com0 graficar_diagrama', @_);
  my ($ref0, $imprlog) = @_;
  impr_debug(__LINE__.' sim0 $ref0',Dumper $ref0);
  impr_todo(__LINE__.' sim0',$ref0);
  my $opciones_sim3 = '';
  $opciones_sim3 .= ' -d ' if $opt_hash{d};
  $opciones_sim3 .= ' -noclas ' if $opt_hash{noclas};
  $opciones_sim3 .= " -g $opt_hash{graf} " if $opt_hash{graf}; 
  $opciones_sim3 .= ' -noverb ' if $opt_hash{noverb};
  $opciones_sim3 .= " -o $opt_hash{outdir}" if $opt_hash{outdir};
  my $archivo = 'xxxxx';
#      my $norden = $ref0->{numarch}->{$archivo};
      eco("Por graficar o preparar graficos ... : $archivo",1)
        if $imprlog;
      impr_debug(__LINE__.' sim0 $opciones_sim3',$opciones_sim3); 
      my $coderr 
        = system("$SIMUSOLBINDIR/simusol3.pl $opciones_sim3 $archivo");
      $coderr = $coderr/256; 
      if ($coderr == 2) {
             print STDERR "simusol3.pl termino a causa de error line "
               . __LINE__.' sim0',"\n";
      };   
      $coderr == 255 and parar0($coderr,'simusol3.pl');
      $ref0->{codigo}->{s3}->{$archivo} = $coderr;
      next unless $imprlog;
      printf LOGPRIN  "sim3: %3i   %4i", $coderr 
         ,$ref0->{numarch}->{$archivo};
      print LOGPRIN  " $archivo\n";

  print LOGPRIN `date` if $imprlog;
#  impr_debug_listas(__LINE__.' sim0 $ref0->{dirarray},$parag'
#    , $ref0->{dirarray},$parag);
  comfin('fin0 graficar_diagrama');
  return '';
}#graficar_diagrama
# ---------------------------------------------------------------------------
sub impre_diag{
   my $archivo = $_[0];
   my $archivosindia = $archivo;
   $archivosindia =~ s/\.dia$//;
   
   #if ($opt_hash{png}) {
   #    print "Por preparar archivo $archivo.png\n";
   #    system "dia --nosplash -e $archivo.png $archivo"; 
   #    return;
   #};
   print STDERR "simusol -impr $archivo\n";
   my $mensaje = "
     (Error de instalación de Simusol). No puedo preparar el archivo
       gráfico para impresión $archivosindia.eps ni $archivosindia.png";
   my $mensajeextra = "        con la escala $opt_hash{impr} \%";#REVISAR 
   my $mensajedia = "        Use Dia, directamente";
   my @orientacion;
   if ($opt_hash{escala} ) {
      my $escala = $opt_hash{escala};
      die "La escala debe consistir en digitos (porcentaje)\n"
              unless $escala =~ /\d+/;
      my $orie = "/$SIMUSOLLIBDIR/simusol/comPortrait"; 
      open IMPRE, $orie or  die 
        "No existe el archivo $orie\n$mensaje\n$mensajeextra\n$mensajedia\n";
      @orientacion = <IMPRE>;
      close IMPRE;
      my $ultimo = pop @orientacion; chomp $ultimo;
      $orie = "/$SIMUSOLLIBDIR/simusol/finPortrait"; 
      open IMPRE, $orie or die 
        "No existe el archivo $orie\n$mensaje\n$mensajeextra\n$mensajedia\n";
      my @restoorientacion = <IMPRE>; 
      $restoorientacion[0] = "$ultimo$escala$restoorientacion[0]";
      push (@orientacion, @restoorientacion);
   } else {
      my $orie ="/$SIMUSOLLIBDIR/simusol/Portrait";
      open IMPRE, $orie or die "$mensaje\n$mensajedia\n";
      @orientacion = <IMPRE>;
   };
   close IMPRE;
   chomp $orientacion[-1];
   -e 'gnus' or crear_gnus('./');
   -d 'gnus' and -w 'gnus' or die "Necesito trabajar con director gnus\n"; 
   my $archivoleible = $archivo;
   if (not system "zcat $archivo >gnus/llll 2>/dev/null") {
       $archivoleible = "gnus/llll";
   };    
   open(DIA,$archivoleible);
   my @lista_dia = <DIA>; my $texto_dia = join ('',@lista_dia);
   close DIA;
   my ($texto_dia_comienzo,$dummy,$texto_dia_resto) =
       ($texto_dia =~ /^([\W\w\n]+)(<dia:attribute name="paper">)([\W\w\n]+)/);
   defined $texto_dia_comienzo 
       or die "$archivo no es un archivo preparado con Dia";
   my $abre = 1;
   # un archivo .xml de Dia  es una secuencia de cadenas separadas 
   # alternadamentye por < > 
   # los archivos de dia pueden estar o no "pretty printed"
   # entre > y < puede no haber nada; 
   # entre < y > siempre hay algo: dia:... o /dia:
    
   while ($abre and $texto_dia_resto) {
      $texto_dia_resto =~ s/^[^<>]*//; 
      if ($texto_dia_resto =~ s/^(<[^<>]+>)//){
         my $cadena = $1;
         if ($cadena =~ /<\/dia:attribute/){
           $abre --
         } elsif ($cadena =~ /<dia:attribute/){
           $abre ++
         };
      } else {
        exit 500
      }	
    };
    #$texto_dia_resto =~ s/^[^<>]+//;
   open PROVI,  ">gnus/llll";
   print PROVI $texto_dia_comienzo,  @orientacion, $texto_dia_resto; 
   close PROVI ;
   print "Preparando  archivo $archivosindia.eps\n";
  `dia --nosplash -e $archivosindia.eps gnus/llll`; 
        #no se acepta -nosplash pero si --nosplash
   print "Preparando  archivo $archivosindia.png\n";
  `dia --nosplash -e $archivosindia.png gnus/llll`;
} #impre_diag
# ---------------------------------------------------------------------------
sub interpretar_argumentos_0{
  comfin('com0 interpretar_argumentos_0',@_);
  my $ref0 = $_[0]; my ($coderr,$mensaje) = ('','');
  impr_todo(__LINE__.' sim0',$ref0);
  ($coderr,$mensaje) = controlar_reserv_dirs($ref0,'dia');
#  impr_debug(__LINE__.' sim0 dirarray',$ref0->{dirarray});
#  not $coderr and $coderr = controlar_reserv_archivos($ref0);
#  if ($coderr) {
#      $mensaje = " No quedan diagramas"; parar0($coderr,$mensaje);
#  };    
#  impr_debug(__LINE__.' sim0 scalar @$refdirarray',scalar  @$refdirarray);
#  $ref0->{dirarray} = $refdirarray; 
  impr_todo(__LINE__.' sim0',$ref0);
  impr_debug(__LINE__.' sim0',Dumper $ref0->{dirarray});
#  relativizar_dirarray($ref0);
#  impr_debug(__LINE__.' sim0',Dumper $ref0->{dirarray});
#  impr_todo(__LINE__.' sim0',$ref0);
  my $juntos = ''; my $refelegido = {};
  if (@{$ref0->{dirarray}} >1) {
      ($juntos,$refelegido) =
        seleccionar_archivo(1,'.dia',$ref0->{corto},1);
        #primer 1, que admite eleccion conjunta #segundo 1 que puede elegir varios 
  };
  my (@direlegidos,@dircortos,@dircortosins);
  for(my $i = 0; $i < @{$ref0->{dirarray}}; $i ++) {
      my $arch = $ref0->{dirarray}->[$i];
      if ($refelegido->{$arch}) {
          push @direlegidos,$arch; push @dircortos,$arch;
          $arch =~ s/\.[^\/\.]*$//;
          push @dircortosins,$arch
      };
  };
  $ref0->{dirarray} = \@direlegidos; $ref0->{corto} = \@dircortos;
  $ref0->{cortosin} = \@dircortosins; 
  $ref0->{juntos} = $juntos;
  impr_todo(__LINE__.' sim0',$ref0);
  comfin('fin0 interpretar_argumentos_0');
  return '';
}#interpretar_argumentos_0
# ---------------------------------------------------------------------------
sub interpretar_argumentos_buscar_0{
  comfin('com0 interpretar_argumentos_buscar_0',@_);
  my $ref0 = $_[0];
  my $reg = $opt_hash{buscar}; $reg =~ /\.dia$/ or $reg .= '.dia';
  impr_debug(__LINE__.' sim0 $reg',$reg);
  my $refpartidas = $opt_hash{path};
  $refpartidas or $refpartidas = [$curdirori]; 
  my (@dirar,@dirarray);
  foreach my $partida (@$refpartidas) {
      impr_debug(__LINE__.' sim0 $partida',$partida);
      next unless -d $partida;
      my @lista = `find $partida -name '$reg' 2>/tmp/null`; chomp @lista;
      impr_debug(__LINE__.' sim0',Dumper \@lista);
      push @dirarray,@lista;
  };
  if (@dirarray == 0) {
      $mensaje = " No se encontraron diagramas"; $coderr = 254;
      return $coderr,$mensaje;
  }; 
  my $curdirori = $ref0->{curdirori};
  foreach my $arch (@dirarray) {
      my ($basearch,$propio,$corto,$propiosin,$cortosin) = relativizar($arch,$curdirori);
      push @{$ref0->{dirarray}},$corto; push @{$ref0->{corto}},$corto;
      push @{$ref0->{cortosin}},$cortosin;
#  impr_debug(__LINE__.' sim0',Dumper \@dirarray);
#  $ref0->{dirarray} = \@dirarray;
  };
  impr_todo(__LINE__.' sim0',$ref0);    
  comfin('fin0 interpretar_argumentos_buscar_0 $coderr,$mensaje'
    ,$coderr,$mensaje);
  return $coderr,$mensaje;
}#interpretar_argumentos_buscar_0';
# ---------------------------------------------------------------------------
sub interpretar_argumentos_no_buscar_0{
  comfin('com0 interpretar_argumentos_no_buscar_0',@_);
  my $ref0 = $_[0]; my ($coderr,$mensaje) = ('','');
  impr_debug(__LINE__.' sim0 @ARGV',\@ARGV);
  my @dirarray;
  if (@ARGV == 0) {
      my $string = $ref0->{curdirori}.'*.dia'; 
      @dirarray = `ls $string 2>/tmp/null`; chomp @dirarray;
      if (@dirarray == 0) {
          $mensaje = 
           " En esta carpeta no hay archivos de extension .dia para procesar";
          $coderr = 253;
	  parar0($coderr,$mensaje);
      };	  
  } elsif (grep (do {$_ =~ /\*/},@ARGV)) {
      my @listatotal;
      my (@conast,@sinast,@listanoast); 
      foreach my $parte (@ARGV) {
	  $parte =~ /\*/ and push @conast,$parte or push @sinast,$parte;
      };
      foreach my $parte (@conast) {	  
          my @lista = `ls $parte 2>/tmp/null`; chomp @lista;
	  push @listatotal,@lista;
      };
      @listanoast = grep(do { /\.dia$/},@listatotal);
      foreach my $parte (@sinast) {
          my $string = $curdirori .'*.dia';	  
          my @lista = `ls $parte 2>/tmp/null`; chomp @lista;
	  push @listanoast,@lista;
      };
      @dirarray = @listanoast;
  } else {
      @dirarray = @ARGV;
  };    
  existencia($ref0,'.dia',@dirarray);
  comfin('fin0 interpretar_argumentos_no_buscar_0 $ref0 $coderr,$mensaje');
  return $coderr,$mensaje;
}#interpretar_argumentos_no_buscar_0
# ---------------------------------------------------------------------------
sub interpretar_opciones_0{
  my $ref0 = $_[0]; my ($coderr,$mensaje) = ('','');
  my @opciones_todas = qw(listar impr imprlog escala=i graf=s
             nocoment noclas nosim notrad noverb
             todas=s d help version
             backup borrarbackups=s cadena comp   
             modelos=s@ elementos=s@ buscar=s path=s@
             reg=s
             extension=s ejecutar=s outdir=s adsim);
# Ahora @ARGV haba perdido lo relativo a las opciones
  my @opciones_s_i = grep (/=/,@opciones_todas);
  GetOptions(\%opt_hash,@opciones_todas) or  pod2usage(2); 	   
  print STDERR ".....  com0 interpretar_opciones_0($ref0)\n" if $opt_hash{d};
# ---------------------------------------------------------------------------
  $debug = $opt_hash{d}; #$debug está definida con our en Ayudas.pm
  $noverb = $opt_hash{noverb};
  impr_debug(__LINE__.' sim0 %opt_hash',\%opt_hash);
# ---------------------------------------------------------------------------
  foreach my $opcsi (@opciones_s_i) {
      $opcsi =~ s/=.*$//;
      my $valorsi  = $opt_hash{$opcsi};
      if (defined $valorsi and $valorsi =~ s/^\-//) {
          foreach my $opctoda (@opciones_todas) {
              if ($valorsi =~ /^$opctoda/) {
                  $mensaje .= "\n La opcion $opcsi necesita un valor
                  no es válido el valor -$valorsi"; $coderr = 250;
                  parar0($coderr,$mensaje);
              };
          }; 
      };
  };
  $opt_hash{reg} and $opt_hash{buscar} = $opt_hash{reg};
  $opt_hash{listar} and $opt_hash{buscar} and do {
      explic(" Si se usa -listar, -buscar no hace nada");
      delete $opt_hash{buscar};
  };
  help() if defined $opt_hash{help};
  version() if defined $opt_hash{version};
 # ---------------------
  defined $opt_hash{graf} or $opt_hash{graf} = 3;
#  if ($opt_hash{outdir} and $opt_hash{backup}) {
#      $coderr = 250;
#      parar0($coderr,"No correponde atender juntas -outdir y -backup");
#  };
if ($opt_hash{backup} or $opt_hash{borrarbackups}) {
   @extensionesbackup = qw(res simul caj d paraplot gra par);
};  
# -----------------------------------------------------------------------------
  if ($opt_hash{noclas}) {
      foreach my $key (keys %dirsalida) {
          substr($dirsalida{$key},0,1) ne 'c' and
            $dirsalida{$key} = '';
      };
  };
# -----------------------------------------------------------------------------
  resolver_outdir($ref0);
  ($coderr,$mensaje) = controlar_reserv_dirs($ref0,1);
  $coderr and parar0($coderr,$mensaje);
  system "rm $ref0->{outdir}simusol.log 2>/dev/null";
  impr_todo(__LINE__.' sim0',$ref0);
  calcular_dirsal();
  comfin('fin0 interpretar_opciones_0,$coderr,$mensaje',$coderr,$mensaje);
  return $coderr,$mensaje;
}#interpretar_opciones_0
# -----------------------------------------------------------------------------
sub procesar_diagramas{
  comfin('com0 procesar_diagramas',$ref0);
  my $ref0 = $_[0];my $codigo_1;
  impr_todo(__LINE__.' sim0',$ref0);
  cargar_opciones_generales();
  if ($opt_hash{comp}) {
      comparar_todo_preparar($ref0);
  };    
  if ($ref0->{juntos}) {
      my $archjuntos = join(' ',@{$ref0->{dirarray}});
      $codigo_1 = procesar_1($archjuntos);
      $ref0->{codigo_1} = $codigo_1;
      procesar_resto($ref0,$codigo_1,0);
  } else {
      for(my $numarch = 0; $numarch < @{$ref0->{cortosin}}; $numarch ++) {
	  impr_debug(__LINE__.' sim0 archivo $ref0->{corto}->[$numarch]',
		     [$numarch,$ref0->{corto}->[$numarch]]);
          $codigo_1 = procesar_1($ref0->{cortosin}->[$numarch]);
	  if ($codigo_1 != 0) {
	      push @{$ref0->{codigo_s}},99; push @{$ref0->{codigo_3}},99;
	  };    
          procesar_resto($ref0,$codigo_1,$numarch);
#          reiterar_mensajes($ref0->{cortosin}->[$numarch]);
          if ($opt_hash{comp}) {
              my $simusolcomp = $ref0->{outdir} . "simusol_comp.log";
              print STDERR "$simusolcomp\n";
              impr_debug(__LINE__.' sim0 $simusolcomp',$simusolcomp);
              -e $simusolcomp and system "less $simusolcomp";
          };
      };
  }	  
  comfin('fin0 procesar_diagramas',$ref0);
  parar0(0,'');
}#procesar_diagramas  
# -----------------------------------------------------------------------------
sub procesar_1{
  comfin('com0 procesar_1',@_);
  my $cortosin  = $_[0];
  impr_debug(__LINE__.' sim0 comando',
    "$SIMUSOLBINDIR/simusol1.pl $opciones{sim1} $cortosin");    
  my $codigo_1 = system "$SIMUSOLBINDIR/simusol1.pl $opciones{sim1} $cortosin";
  $codigo_1 = $codigo_1/256;
  if ($codigo_1 == 255) {
      error_progr(__FILE__,__LINE__,' Error de sintaxis en simusol1.pl');
  };    
  push @{$ref0->{codigo_1}},$codigo_1;
  comfin('fin0 procesar_1');
  return $codigo_1;
}#procesar_1';
# -----------------------------------------------------------------------------
sub procesar_resto{
  comfin('com0 procesar_resto',@_);
  my ($ref0,$codigo_1,$numarch) = @_; my ($codigo_s,$codigo_3) = (99,99);
#  my ($corto,$cortosin,$basearchcorto) = procesar_simusollog($ref0,$numarch);
  my $cortosin;
  if (not $codigo_1 and not $opt_hash{nosim}) {
      print STDERR "numarch $numarch\n"; 
      $cortosin = $ref0->{cortosin}->[$numarch];
      my $comando = "$SIMUSOLBINDIR/lolisol_sceptre.pl $opciones{sims} $cortosin";
      impr_debug(__LINE__.' sim0 $comando',$comando);
      $codigo_s = system $comando;
      $codigo_s = $codigo_s/256; 
  } else {
      comfin('fin0 procesar_resto');
      return 0;
  };      
  push @{$ref0->{codigo_s}},$codigo_s;
  my $comando = "$SIMUSOLBINDIR/simusol3.pl $opciones{sim3} $cortosin";
  impr_debug(__LINE__.' sim0 $comando',$comando);
  if (not $codigo_s) {
      $codigo_3 = system $comando;
      $codigo_3 = $codigo_3/256;
  };
  push @{$ref0->{codigo_3}},$codigo_3;
  impr_todo(__LINE__.' sim0',$ref0);
  if ($opt_hash{comp}){
      comparar_todo($ref0,$numarch);
  };    
  comfin('fin0 procesar_resto');
  return '';
}#procesar_resto;
# -----------------------------------------------------------------------------
sub procesar_simusollog{#a partir del archivo simusol.log,
# $corto, $cortosin, $basearchcorto
#por ahora dejo el mismo 
  comfin('com0 procesar_simusollog',@_);
  my ($ref0,$numarch) = @_; my ($corto,$cortosin,$basearchcorto);
  impr_todo(__LINE__.' sim0',$ref0);
#  my $archsimusollog =
#      "$ref0->{outdir}$ref0->{basearchcorto}[$numarch]$ref0->{cortosin}->[$numarch]";
  my @archsimusollog = `cat $ref0->{outdir}simusol.log`;
  impr_debug(__LINE__.' sim0',\@archsimusollog);die;
  ($corto,$cortosin,$basearchcorto) =
     ($ref0->{corto}->[$numarch],$ref0->{cortosin}->[$numarch],
      $ref0->{basearchcorto}->[$numarch]);
  comfin('fin0 procesar_simusollog,$corto,$cortosin,$basearchcorto',
         $corto,$cortosin,$basearchcorto);
  return $corto,$cortosin,$basearchcorto;
}#procesar_simusollog

# -----------------------------------------------------------------------------
sub parar0{
  comfin('com0 parar0',@_);
  my ($codigo,$mensaje) = @_;
  print LOGPRIN "$codigo\n$mensaje\n" if $imprlog;
  mensajear($mensaje); 
  comfin('fin0 parar0');
  exit $codigo;
}#parar0
# --------------------------------------------------------------------------
sub reiterar_mensajes{
  comfin('com0 reiterar_mensajes',@_);
  my ($cortosin,$numarch) = @_;  
  my $extls3 = 'ls3';$opt_hash{noclas} and $extls3 = 'lss1'; 
  my $archls3 = "$dirsalida{ls3}$cortosin.$extls3";
  if (-e $archls3) {system "less $archls3";
#      if (not system "grep 'ERROR GRAVE' $archls3 2>/dev/null") {
#          if ($ref0->{codigo_1}->[$numarch] <250) {        
#              explic(' ----------- REITERACION DE MENSAJES: -------');
#              my @errores = `cat $archls3`;
#              @errores = grep(do{ $_!~/Mensajes de/ and $_ !~ /de fecha/}
#                              , @errores);
#              print @errores;
#          } else {# hay .d que no se ejecuta
#              explic(" Vuelva a ver los mensajes en $archls3"); 
#          };
#      } elsif (not system "grep 'ERROR ' $archls3 2>/dev/null") {
#          explic( " Hubo avisos; véalos más arriba o 
#            en el archivo  $archls3"); 
#      };
  };
  comfin('fin0 reiterar_mensajes');        
}#reiterar_mensajes'    
# --------------------------------------------------------------------------
sub simular_diagrama{
  comfin('com0 simular_diagrama', @_);
  my ($ref0, $imprlog) = @_;
  impr_todo(__LINE__.' sim0',$ref0); 
  my $opciones_sceptre ='';  
  $opciones_sceptre .= ' -d ' if $opt_hash{d};
  $opciones_sceptre .= ' -noclas ' if $opt_hash{noclas};
  $opciones_sceptre .= ' -noverb ' if $opt_hash{noverb};
  $opciones_sceptre .= ' -adsim ' if $opt_hash{adsim};
  $opciones_sceptre .= " -o $opt_hash{outdir} " if $opt_hash{outdir}; 
  my (@parag,@mal);
  impr_debug(__LINE__.' sim0 $opciones_sceptre ',$opciones_sceptre);
  my $archivo = 'xxxx';

      my $norden = $ref0->{numarch}->{$archivo};
      if (not $norden) {
          $norden = $ref0->{numarch}->{$archivo} = 1;
      };
      eco("Por simular $norden: $archivo",1) if $imprlog;
      my $archivosin = $ref0->{dirsin}->[$norden -1];
      my $comandos = 
        "$SIMUSOLBINDIR/simusol_sceptre.pl $opciones_sceptre $archivo";
#      print STDERR "$comandos\n";
      my $coderr = system
          "$SIMUSOLBINDIR/simusol_sceptre.pl $opciones_sceptre $archivo";
      $coderr = $coderr/256; 
      if ($coderr == 2) {
             print STDERR "simusol_sceptre.pl termino a causa de error line "
               . __LINE__.' sim0',"\n";
      };   
      $coderr == 255 and parar0($coderr,'simusol_sceptre');
      $ref0->{codigo}->{ss}->{$archivo} = $coderr; 
      if ($coderr > 1) {
          push @mal,$archivo;
      } else {
          push @parag, $archivo; 
      };
      next unless $imprlog;
      my $numero = 1;
      $ref0->{numarch}->{$archivo} and $numero = $ref0->{numarch}->{$archivo};
      printf LOGPRIN  "scep: %3s   %4s", $coderr,$numero;
      print LOGPRIN " $archivo\n";
  print LOGPRIN `date` if $imprlog;
  comfin('fin0 simular_diagrama');
  return
}#simular_diagrama
# -----------------------------------------------------------------------------
sub traducir_diagramas{
  comfin('com0 traducir_diagramas', @_);
  my ($ref0,$imprlog) = @_;
  my $juntos = $ref0->{juntos};
  my $codigosim0= 0;
  impr_todo(__LINE__.' sim0',$ref0);
  if ($juntos) {
      my $archivos = join(' ',@{$ref0->{corto}}); # se supone uno solo, multiple
      eco("Por traducir $archivos",1);
      my $codigo_1 = system 
            "$SIMUSOLBINDIR/simusol1.pl $opciones{sim1} \'$archivos\'";
      $codigo_1 = $codigo_1/256; 
      push @{$ref0->{codigo_1}},$codigo_1; 
       impr_debug(__LINE__.' sim0 $ref0',Dumper $ref0);
      if ($codigo_1 == 2) {
             print STDERR "simusol1.pl termino a causa de error line "
               . __LINE__.' sim0',"\n";
      };   
      if ($codigo_1 >= 250 or $codigo_1 == 2) {
          parar0($codigo_1,"simusol1.pl");
      };
      return; 
  } else {
      impr_todo(__LINE__.' sim0',$ref0);
      system "rm $gnusdir/* 2>/dev/null; rmdir $gnusdir 2>/dev/null" 
          if  -d $gnusdir;
      for (my $numarch = 0; $numarch < @{$ref0->{corto}}; $numarch ++) {
          my $corto = $ref0->{corto}->[$numarch];
	  eco("Por procesar  $corto") if $imprlog;
          my $norden = $numarch+1;
          my $cortosin = $ref0->{cortosins}->[$numarch];    
          eco("Por traducir $norden: $corto",1) if $imprlog;
          my $comando1 =  "$SIMUSOLBINDIR/simusol1.pl $opciones_sim1 $corto";
          impr_debug(__LINE__.' sim0 ',$comando1);
          my $codigo_1 = system 
            "$SIMUSOLBINDIR/simusol1.pl $opciones_sim1 $corto";
          $codigo_1 = $codigo_1/256;
	  push @{$ref0->{codigo_1}},$codigo_1;
          impr_todo(__LINE__.' sim0',$ref0);
	  print LOGPRIN "$ref0->{corto}->[-1], codigo_1, $codigo_1\n" if $imprlog;
#          system "less $ref0->{outdir}simusol.log"; die; 
         if ($codigo_1 == 2) {
          # $codigo_1 igual a 2  (512) puede corresponder a que hubo error en 
          # la ejecucion anterior; por eso el 2 para grafico se ha cambiado a 12
              print STDERR "simusol1.pl termino a causa de error line "
               . __LINE__.' sim0',"\n";
          };   
          if ($codigo_1 == 255 or
               $codigo_1 == 2) {
               parar0($codigo_1,'simusol1.pl');
          };  
          $codigo_1 >= 250 and do { $codigosim0 = $codigo_1; next};
          $codigo_1 > $codigosim0 and $codigosim0 = $codigo_1;
          if ($codigo_1 <= 12) {
              if ($opt_hash{todas}) {
#                 my $norden = $ref0->{numarch}->{$archivo};
                  (my $agre = $opt_hash{todas}) =~ s/\s+/_/g;
                  my $cortosin = $ref0->{cortosin}->[$numarch];
	          $cortosin .=  $agre;
	          $ref0->{cortosin}->[$numarch] = $cortosin; 
              }; 
          };  
          next unless $imprlog;
          print LOGPRIN " $corto\n" ; 

      };#for my $numarch
  }; 
  print LOGPRIN `date` if $imprlog;
#  if (not @$parasceptre and not @$solograficar and not $opt_hash{comp}) {
#      explic(" No hay mas que hacer");
#      parar0($codigosim0,'simusol1.pl');
#  };
#  impr_todo(__LINE__.' sim0',$ref0);
  comfin('fin0 traducir_diagramas');
  return;
}#traducir_diagramas
#----------------------------------------------------------------------------
sub help{
my $nivel = 0;
    $nivel = $_[0] if @_;  
    pod2usage({-verbose => $nivel
	   ,-exit => 1
	   ,-message => "   $progname  $version
       es el script principal  de S I M U S O L
            más ayuda con   
	       man $progname
	    y luego salga con   q\n"   
	   });	   
}
#----------------------------------------------------------------------------
sub version{
    print "\n      $progname  $version\n\n";
    exit
}
